
#define p_scl	PORTD
#define d_scl	DDRD
#define p_sda	PORTD
#define d_sda	DDRD
#define scl		4
#define sda		3

volatile bool F1;	// (   )
volatile bool F2;
volatile bool F3;
volatile bool F4;
volatile bool send;	//  
volatile bool RLO;		//  


u8 count_cycl;			//


//   =================================================
#define	FN(ax, fx, rlo)	do{if(!ax&&fx){rlo=true;}else{rlo=false;} fx=ax;  }while(0)
//  SCL(PD4);=============================================================
#define SCLup	do{p_scl&=~(1<<scl);d_scl&=~(1<<scl);  }while(0)
//  SDA(PD3)==============================================================
#define SDAup	do{p_sda&=~(1<<sda);d_sda&=~(1<<sda);  }while(0)
//  SCL(PD4)==================================================================
#define SCLdown	do{p_scl&=~(1<<scl); d_scl|=1<<scl;  }while(0)
//  SDA(PD3)===================================================================
#define SDAdown	do{p_sda&=~(1<<sda);d_sda|=1<<sda;  }while(0)
//=========================================




// =========================================================================
void send_byte(u8 byte)
{
	if(!(send))
	{
	send=true; 
	count_cycl=0;
	}else{
			switch(count_cycl)
			{
				case 0:	//  
					SCLup; SDAup;
				break;
				case 1:
					SDAdown;
				break;
				case 2:
					SCLdown;
				break;
				case 3:	//  7  SDA
					if(byte&1<<7){SDAup;}else{SDAdown;}	
				break;
				case 4:	//4-5 -  
					SCLup;
				break;
				case 5:
					SCLdown;
				break;
				case 6:	//  6  SDA
					if(byte&1<<6){SDAup;}else{SDAdown;}
				break;
				case 7:	//7-8 - 
					SCLup;
				break;
				case 8:
					SCLdown;
				break;
				case 9:	//  5  SDA
					if(byte&1<<5){SDAup;}else{SDAdown;}
				break;
				case 10:	//10-11 - 
					SCLup;
				break;
				case 11:
					SCLdown;
				break;
				case 12:	//  4
					if(byte&1<<4){SDAup;}else{SDAdown;}
				break;
				case 13:	//13-14 - 
					SCLup;
				break;
				case 14:
					SCLdown;
				break;
				case 15:	//  3
					if(byte&1<<3){SDAup;}else{SDAdown;}
				break;
				case 16:	//16-17 - 
					SCLup;
				break;
				case 17:
					SCLdown;
				break;
				case 18:	//  2
					if(byte&1<<2){SDAup;}else{SDAdown;}
				break;
				case 19:	//19-20 - 
					SCLup;
				break;
				case 20:
					SCLdown;
				break;
				case 21: //  1
					if(byte&1<<1){SDAup;}else{SDAdown;}
				break;
				case 22:	//22-23 - 
					SCLup;
				break;
				case 23:
					SCLdown;
				break;
				case 24:	//  0
					if(byte&1<<0){SDAup;}else{SDAdown;}
				break;
				case 25:	//25-26 - 
					SCLup;
				break;
				case 26:
					SCLdown;
				break;
				case 27:	// 
					SDAdown; SCLup;
				break;
				case 28:
					SDAup;
				break;
			}
			if(send)
				count_cycl++;
			if(count_cycl>28)
				send=false;

		}
};








































